function [share,nopurch] = mksharesimBIG(betatrue,T,x,xi,oo,oo1,rc);

%%%%%%%%%%%%
% mksharesimBIG - generates market share data
%   uses loops to accommodate a large number of draws
%   to simulate the integral in the shares.
%   If number of draws is small (i.e. less than 15,000)
%   then use mksharesim.m
%
%   JP Dube, December 20,2007

global euler prods datasort

delta = x*betatrue+xi;

share = zeros(T*prods,1);
nopurch = zeros(T,1);
for tt = 1:T,
    index = (0:prods-1)*T+tt;
    MU = x(index,:)*rc;
    numer = exp( repmat(delta(index,:),1,size(rc,2)) + MU );
    denom = 1+sum(numer);
    share(index) = mean( numer./repmat(denom,prods,1) , 2);
    nopurch(tt) = 1-sum(share(index));
end
