function [c] = GMMMPEC_c(x0)

% GMMMPEC_c
% Constraints for the random coefficients Logit estimated via MPEC.
%
% source: Dube, Fox and Su (2008)
% Code Revised: April 2008


global x1 x2 IV K D prods T Dthet

theta1 = x0(1:prods+1, 1);
theta2 = x0(prods+2:prods+K+Dthet+2, 1);
delta = x0(prods+K+Dthet+3:prods+K+Dthet+2+T*prods, 1);
g = x0(prods+K+Dthet+3+T*prods:end, 1);

cong = g - IV'*(delta - x1*theta1);
MU = mufuncnormMPEC(theta2);
expmu = exp(MU); 
expmval = exp(delta);
logEstShares = log(ind_shnorm(expmval,expmu));

% c = logEstShares ;

c = [logEstShares ;
      cong ];
