function [f] = GMMMPEC_f(x0)

% GMMMPEC_f
% GMM Objective function for the random coefficients Logit esitmated via
% MPEC.
%
% source: Dube, Fox and Su (2008)
% Code Revised: April 2008


global W K prods T Dthet

theta1 = x0(1:prods+1, 1);
theta2 = x0(prods+2:prods+K+Dthet+2, 1);
delta = x0(prods+K+Dthet+3:prods+K+Dthet+2+T*prods, 1);
g = x0(prods+K+Dthet+3+T*prods:end, 1);

f = g'*W*g; 

%iteration = iteration +1;
%if iteration/report==ceil(iteration/report),
%    disp(['GMM objective:      ' num2str(f)])
%    disp(['# Function Evals:   ' num2str(iteration)])
%    disp(' ')
%end
