function [hess_f] = GMMMPEC_hess(x0)

% GMMMPEC_hess
% Hessian of the GMM obhective function for the random coefficients Logit
% estimated via MPEC.
%
% source: Dube, Fox and Su (2008)
% Code Revised: April 2008

global W K prods T Dthet

theta1 = x0(1:prods+1, 1);
theta2 = x0(prods+2:prods+K+Dthet+2, 1);
delta = x0(prods+K+Dthet+3:prods+K+Dthet+2+T*prods, 1);
g = x0(prods+K+Dthet+3+T*prods:end, 1);

nx0 = size(x0,1);
hess_f = zeros(nx0,nx0);
hess_f(prods+K+Dthet+3+T*prods:end,prods+K+Dthet+3+T*prods:end) = 2*W;
