function Dg = analyticderiv(theta2)

% Analyticderiv
% Computes the analytic derivatives for the GMM Objective Function
% of the random coefficients Logit demand model estimated via NFP.
%
% source: Dube, Fox and Su (2008)
% Code Revised: May 2008

global prods T nn v K D demogr setuprc x1 x2 IV W resid cholesky delta keepdem vfull dfull 

% cholmat = zeros(K);
% if cholesky==K,
%     cholmat = diag(theta2);
% elseif cholesky==K*(K-1),
%     cholmat(setuprc) = theta2;
% end
% nu = cholmat*v;

theta = theta2(1:K+1);
thetadem = theta2(K+2:end);
thetadem1 = zeros(D);
thetadem1(keepdem) = thetadem;

MU = mufuncnorm(theta2);
expmu = exp(MU); 
expmval = exp(delta);
[EstShare, simShare] = ind_shnormMPEC(expmval,expmu);

ooo = ones(1,K+1);
ooo1 = ones(prods,1);
% dSdtheta2 = zeros(T*prods,K+1);
dSdtheta2 = zeros(T*prods,20);
dSddeltaDIAG = zeros(T*prods,prods);

for tt=1:T,
    index = (0:prods-1)'*T+tt;
    for rr = 1:nn,
        dSddeltaDIAG(index,:) = dSddeltaDIAG(index,:) + (diag(simShare(index,rr)) - simShare(index,rr)*simShare(index,rr)')/nn;
       
        v_i = vfull(:,rr:nn:(K+1)*nn);
        d_i = dfull(:,rr:nn:D*nn);
        
        % size(v_i(index,:))
        
        % MU(:,ii) = (x2.*v_i*theta(:,1))+x2.*(d_i*thetadem1')*ones(K+1,1);
       
        % dSdtheta2(index,:) = dSdtheta2(index,:) + (simShare(index,rr)*ooo).*(ooo1*v(:,rr)').*( x2(index,:) - (ooo1*(simShare(index,rr)'*x2(index,:))))/nn;
        dSdtheta2(index,1:K+1) = dSdtheta2(index,1:K+1) + (simShare(index,rr)*ooo).*(v_i(index,:)).*( x2(index,:) - (ooo1*(simShare(index,rr)'*x2(index,:))))/nn;
        for d = 1:D
            dSdtheta2(index,1+d*4:(d+1)*4) = dSdtheta2(index,d*4+1:(d+1)*4) + (simShare(index,rr)*ooo).*(d_i(index,d)*ooo).*( x2(index,:) - (ooo1*(simShare(index,rr)'*x2(index,:))))/nn;
        end
    end
end

dSddelta = zeros(T*prods, T*prods);
for i = 1:prods
    for j = 1:prods
    dSddelta( (j-1)*T+1:j*T, (i-1)*T+1:i*T ) = diag(dSddeltaDIAG((j-1)*T+1:j*T, i)); 
    end
end

Ddelta = -inv(dSddelta)*dSdtheta2(:,[(1:4)';4+keepdem]');
Dg = 2*Ddelta'*IV*W*IV'*resid;
