function MU = mufuncnormMPEC(theta2)

% MUFUNCNORMMPEC
% Computes the utility associated with the unobserved component of the r.c.'s.
%
% source: Dube, Fox and Su (2008)
% Code Revised: April 2008

global x2 v K T D keepdem vfull dfull prods nn

if size(v,1)==T,
    theta = theta2(1:K+1);
    thetadem = theta2(K+2:end);
    thetadem1 = zeros(D);
    thetadem1(keepdem) = thetadem;
    MU = zeros(T*prods,nn);
    for ii=1:nn,
        v_i = vfull(:,ii:nn:(K+1)*nn);
        d_i = dfull(:,ii:nn:D*nn);
        MU(:,ii) = (x2.*v_i*theta(:,1))+x2.*(d_i*thetadem1')*ones(K+1,1);
    end
elseif size(v,1)==K+1,
    nu = cholmat*v;
    MU = x2*nu;
end
