function [theta,G,INFO,CPUt,FuncEval,GradEval,reps,Dg,cov] = runGMMBLPTomlab(theta00,W,mvalold0,deriv,gradient)

% run GMMBLPTomlab
% Run the GMM estimation of the random coefficients Logit demand model estimated via NFP.
%
% source: Dube, Fox and Su (2008)
% Code Revised: May 2008

global iteration mvalold theta1 T prods tol_inner tol_outer rr

if nargin<5, gradient=0; end;

iteration = 0;
INFO = -1;
reps =0;
CPUt = 0;
mvalold = mvalold0;
differ = 1;
while INFO ~= 1 && reps < 1,
    % Setup the lower and upper bounds for varialbes and constraints

    [thetalow,thetaupp,Flow,Fupp] = GMMBLPSetup(theta00);
    

    %optionsSimplex = optimset('TolFun',tol_outer,'MaxFunEvals',100000,'MaxIter',10000,'Display','iter');
    optionsSimplex = optimset('MaxFunEvals',100000,'MaxIter',10000,'Display','iter');
    
    tic;    
    [theta,G,INFO,output] = fminsearch(@gmmobjnormsnopt,theta00,optionsSimplex);
    CPUt = toc;
    
    FuncEval = output.funcCount;
    GradEval = 0;
    Iters = output.iterations;
    
    ExitMessage = output.message;
    
    %    diff = max(abs(theta00-theta)./theta);
    theta00 = theta;
    reps = reps+1;
end

if deriv==1,    %4
    Dg = mkderivGMMnorm(theta1,theta,1.e-5);
    cov = inv(Dg*W*Dg')/(T*prods);
else
    Dg = [];
    cov = [];
end


disp(['Monte Carlo Replication ' num2str(rr)])
disp(['# runs of optimizer     ' num2str(reps)])
disp(' ')
