clear
global nn K v vfull dfull
global y share W denomexpand sharesum PX x1 IV setuprc cholesky keepdem D Dthet
global T prods theta1 oo tol_inner tol_outer report

diary NevoDataNFPtightlooseMPEC-50run.out;

% load data. see description in readme.txt
load ps2
load iv
IV = [iv(:,2:21) x1(:,2:25)];
clear iv

ns = 20;       % number of simulated "indviduals" per market %
nmkt = 94;     % number of markets = (# of cities)*(# of quarters)  %
prods = 24;    % number of brands per market. if the numebr differs by market this requires some "accounting" vector %

cdid = kron([1:nmkt]',ones(prods,1));    
cdid = kron([1:nmkt]',ones(prods,1));    
cdindex = [prods:prods:prods*nmkt]';       
temp = cumsum(s_jt);
sum1 = temp(cdindex,:);
sum1(2:size(sum1,1),:) = diff(sum1);
outshr = 1.0 - sum1(cdid,:);
vfull = v(cdid,:);                                  % normal draws
dfull = demogr(cdid,:);                             % demographic draws
theta2w=    [0.3302   5.4819         0    0.2037         0;
             2.4526  15.8935    -1.2000        0    2.6342;
             0.0163  -0.2506         0    0.0511         0;
             0.2441   1.2650         0   -0.8091         0];
keepdem = find(theta2w(:,2:end));

%%%% SET UP DATA TO BE COMPATIBLE WITH OUR CODE
K = size(x2,2)-1;                                   % number characteristics (other than price)
D = size(dfull,2)/ns;                               % number demographics
Dthet = length(keepdem);                            % number demographic parameters
T = nmkt;                                           % number of markets
randn('seed',155)                                   % reset normal random number generator
rand('seed',155)                                    % reset uniform random number generator
%nn = 100;
%v = randn(K+1,nn);                                  % draws for share integrals during estimation
nn = ns;
v = vfull;
dem = dfull;
share = s_jt;
y = log(s_jt) - log(outshr);

% Sort data by product then market (to work with our code)
sortdata = sortrows([(1:nmkt*prods)' repmat((1:prods)',nmkt,1) cdid],[2 3]);
sortdata = sortdata(:,1);
x1 = x1(sortdata,:);
x2 = x2(sortdata,:);
y = y(sortdata,:);
s_jt = s_jt(sortdata,:);
share = s_jt;
outshr = outshr(sortdata,:);
IV = IV(sortdata,:);
mkt = repmat((1:T)',prods,1);
vfull = vfull(sortdata,:);
dfull = dfull(sortdata,:);

%%%% EDIT FOLLOWING LINES IF YOU WANT TO WORK WITH A SMALLER SAMPLE THAN
%%%% ALL 94 MARKETS
T =94;
x1 = x1(mkt<=T,:);
x2 = x2(mkt<=T,:);
y = y(mkt<=T,:);
share = s_jt(mkt<=T,:);
outshr = outshr(mkt<=T,:);
IV = IV(mkt<=T,:);
mkt = mkt(mkt<=T,:);
v = v(1:T,:);
vfull = vfull(mkt<=T,:);
dfull = dfull(mkt<=T,:);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2SLS ESTIMATION OF HOMOGENEOUS LOGIT MODEL %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xhat = IV*inv(IV'*IV)*IV'*x1;
PX2sls = inv(xhat'*xhat)*xhat';           % project. matrix on weighted x-space for 2SLS
betaols = inv(x1'*x1)*x1'*y;
seols = sqrt(diag( mean((y-x1*betaols).^2)*inv(x1'*x1) ));
beta2sls = PX2sls*y;
cov2sls = mean((y-x1*beta2sls).^2)*inv(xhat'*xhat);
se2sls = sqrt(diag( cov2sls ));
x2nd = x2((0:prods-1)*T+1,[1 3:end]);
%beta2sls2nd = regress(beta2sls(2:end),x2nd);
beta2sls2nd = inv( x2nd'*inv(cov2sls(2:end,2:end))*x2nd )*x2nd'*inv(cov2sls(2:end,2:end))*beta2sls(2:end);
save 2sls betaols beta2sls seols se2sls

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% R.C. Logit
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% startvalues = [zeros(K+1+Dthet,1),repmat(0.5*abs([beta2sls(1);beta2sls2nd;randn(Dthet,1)]),1,30).*(1 + [zeros(K+1+Dthet,1) , rand(K+1+Dthet,29)])];

[theti, thetj, theta2]=find(theta2w);

for ii = 1:50
    randn('state',1000*ii);
    aa = normrnd(0,1,size(theta2));
    % aa = normrnd(1,1)*abs(theta2);
    % startvalues(:,ii)=normrnd(0,1,size(theta2));
    startvalues(:,ii) = aa;
end

cholesky = K;                           % set to K*(K-1) for correlated r.c. case
setuprc = find(tril(ones(K)));          % to assemble cholesky matrix for case of correlated r.c.s
mvalold0 = exp(y);
W = inv(IV'*IV);
PX = inv(x1'*IV*W*IV'*x1)*x1'*IV*W*IV';

%%% Create indices to speed share calculations
oo = ones(1,nn);                                    % for use in simulation of shares
sharesum = kron( ones(1,prods),speye(T));           % used to create denominators in shares (sums numerators)
denomexpand = repmat( (1:T)',prods,1);

%%%% Inititalize output matrices
thetaGMMSimplex = [];
JstatSimplex    = [];
timeGMMSimplex = [];
innerlooptimeSimplex = [];
FuncEvGMMSimplex = [];
GradEvGMMSimplex = [];
covGMMSimplex = [];
repsGMMSimplex = [];
INFOGMMSimplex = [];


thetaGMM1tight = [];
Jstat1tight    = [];
timeGMM1tight = [];
innerlooptimetight = [];
FuncEvGMM1tight = [];
GradEvGMM1tight = [];
covGMM1tight = [];
repsGMM1tight = [];
INFOGMM1tight = [];

thetaGMM1loose = [];
Jstat1loose    = [];
timeGMM1loose = [];
FuncEvGMM1loose = [];
GradEvGMM1loose = [];
covGMM1loose = [];
repsGMM1loose = [];
INFOGMM1loose = [];

thetaGMM1loose1 = [];
Jstat1loose1    = [];
timeGMM1loose1 = [];
FuncEvGMM1loose1 = [];
GradEvGMM1loose1 = [];
covGMM1loose1 = [];
repsGMM1loose1 = [];
INFOGMM1loose1 = [];

thetaGMMMPEC = [];
JstatGMMMPEC = [];
timeGMMMPEC = [];
FuncEvGMMMPEC = [];
GradEvGMMMPEC = [];
covGMMMPEC = [];
INFOGMMMPEC = [];

ElasbarBLP = zeros(prods, prods,size(startvalues,2));
ElasbarBLPloose = zeros(prods, prods,size(startvalues,2));
ElasbarBLPloose1 = zeros(prods, prods,size(startvalues,2));
ElasbarMPEC = zeros(prods, prods,size(startvalues,2));

LipschBLP = zeros(size(startvalues,2),1);
LipschBLPloose = zeros(size(startvalues,2),1);

usegradient=1;
% for ii = 1:size(startvalues,2),
for ii = 1:50
    display(['Run #' num2str(ii)])
    theta00 = startvalues(:,ii);
    report = [];

    %%%%%%%%%%%%%%%%%%%%%%%
    % (1) run BLP approach%
    
    % run Nelder-Meade Simplex approach
    tol_inner=1.e-14;
    tol_outer=1.e-6;
    [theta,G,INFO,CPUt,FuncEval,GradEval,reps,Dg,cov] = runGMMBLPTomlab_Simplex(theta00,W,mvalold0,0,0);
    thetaGMMSimplex = [ thetaGMMSimplex, [theta1;theta]];
    JstatSimplex = [JstatSimplex, G/(T*prods)];
    timeGMMSimplex = [timeGMMSimplex, CPUt];
    FuncEvGMMSimplex = [FuncEvGMMSimplex, FuncEval];
    GradEvGMMSimplex = [GradEvGMMSimplex, GradEval]; 
    covGMMSimplex = [covGMMSimplex,cov];
    repsGMMSimplex = [repsGMMSimplex, reps];
    INFOGMMSimplex = [INFOGMMSimplex, INFO];
    mvalold0 = exp(y);
    save GMMstepSimplex thetaGMMSimplex W JstatSimplex timeGMMSimplex FuncEvGMMSimplex GradEvGMMSimplex covGMMSimplex repsGMMSimplex INFOGMMSimplex;
   
    
    % (i) RUN TIGHT INNER LOOP AND TIGHT OUTER LOOP
    tol_inner=1.e-14;
    tol_outer=1.e-6;
    [theta,G,INFO,CPUt,FuncEval,GradEval,reps,Dg,cov] = runGMMBLPTomlab(theta00,W,mvalold0,0,usegradient);
    thetaGMM1tight = [ thetaGMM1tight, [theta1;theta]];
    Jstat1tight = [Jstat1tight, G/(T*prods)];
    timeGMM1tight = [timeGMM1tight, CPUt];
    FuncEvGMM1tight = [FuncEvGMM1tight, FuncEval];
    GradEvGMM1tight = [GradEvGMM1tight, GradEval]; 
    covGMM1tight = [covGMM1tight,cov];
    repsGMM1tight = [repsGMM1tight, reps];
    INFOGMM1tight = [INFOGMM1tight, INFO];
    mvalold0 = exp(y);
    save GMMstep1tight thetaGMM1tight W Jstat1tight timeGMM1tight FuncEvGMM1tight GradEvGMM1tight covGMM1tight repsGMM1tight INFOGMM1tight;
   
    % (ii) RUN LOOSE INNER LOOP AND TIGHT OUTER LOOP
    tol_inner=1.e-4;
    tol_outer=1.e-6;
    mvalold0 = exp(y);
    [theta,G,INFO,CPUt,FuncEval,GradEval,reps,Dg,cov] = runGMMBLPTomlab(theta00,W,mvalold0,0,usegradient);
    thetaGMM1loose = [ thetaGMM1loose, [theta1;theta]];
    Jstat1loose = [Jstat1loose, G/(T*prods)];
    timeGMM1loose = [timeGMM1loose, CPUt];
    FuncEvGMM1loose = [FuncEvGMM1loose, FuncEval];
    GradEvGMM1loose = [GradEvGMM1loose, GradEval]; 
    covGMM1loose = [covGMM1loose,cov];
    repsGMM1loose = [repsGMM1loose, reps];
    INFOGMM1loose = [INFOGMM1loose, INFO]; 
    mvalold0 = exp(y);
    save GMMstep1loose thetaGMM1loose W Jstat1loose timeGMM1loose FuncEvGMM1loose GradEvGMM1loose covGMM1loose repsGMM1loose INFOGMM1loose;

    % (iii) RUN LOOSE INNER LOOP AND LOOSE OUTER LOOP
    tol_inner=1.e-4;
    tol_outer=1.e-2;
    mvalold0 = exp(y);
    [theta,G,INFO,CPUt,FuncEval,GradEval,reps,Dg,cov] = runGMMBLPTomlab(theta00,W,mvalold0,0,usegradient);
    thetaGMM1loose1 = [ thetaGMM1loose1, [theta1;theta]];
    Jstat1loose1 = [Jstat1loose1, G/(T*prods)];
    timeGMM1loose1 = [timeGMM1loose1, CPUt];
    FuncEvGMM1loose1 = [FuncEvGMM1loose1, FuncEval];
    GradEvGMM1loose1 = [GradEvGMM1loose1, GradEval]; 
    covGMM1loose1 = [covGMM1loose1,cov];
    repsGMM1loose1 = [repsGMM1loose1, reps];
    INFOGMM1loose1 = [INFOGMM1loose1, INFO]; 
    mvalold0 = exp(y);
    save GMMstep1loose1 thetaGMM1loose1 W Jstat1loose1 timeGMM1loose1 FuncEvGMM1loose1 GradEvGMM1loose1 covGMM1loose1 repsGMM1loose1 INFOGMM1loose1;    
    
    
    
    %%%%%%%%%%%%%%%%%%%%%%%%
    % (iv) run MPEC approach%
    tol_inner=1.e-14;
    tol_outer=1.e-6;
    nIV = size(IV,2);       % # instrumental variables
    %%% global mvalold
    mvalold = mvalold0;
    % delta0 = meanvalnorm(theta00);
    delta0 = -5*ones(T*prods,1);
    theta10 = PX*delta0;
    resid0 = delta0 - x1*theta10;
    g0 = IV'*resid0;    
    x0 = [theta10; theta00; delta0; g0]; 
    
    [theta1MPEC,theta2MPEC,GMPEC,INFOMPEC,CPUtMPEC,FuncEvalMPEC,GradEvalMPEC,DgMPEC,covMPEC] = runGMMMPECTomlab(x0,0,usegradient);
    
    thetaGMMMPEC = [ thetaGMMMPEC, [theta1MPEC;theta2MPEC]];
    JstatGMMMPEC = [JstatGMMMPEC, GMPEC/(T*prods)];
    timeGMMMPEC = [timeGMMMPEC, CPUtMPEC];
    FuncEvGMMMPEC = [FuncEvGMMMPEC, FuncEvalMPEC]; 
    GradEvGMMMPEC = [GradEvGMMMPEC, GradEvalMPEC]; 
    covGMMMPEC = [covGMMMPEC,covMPEC];
    INFOGMMMPEC = [INFOGMMMPEC, INFOMPEC];
    save GMMMPEC thetaGMMMPEC JstatGMMMPEC timeGMMMPEC FuncEvGMMMPEC GradEvGMMMPEC covGMMMPEC INFOGMMMPEC;
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%% COMPARE ECONOMIC METRICS %%%%
    
    
    thetaBLP1Simplex = thetaGMMSimplex(1:prods+1, ii);
    thetaBLP2Simplex = thetaGMMSimplex(prods+2:prods+1+K+1, ii);
    thetaBLP3Simplex = thetaGMMSimplex(prods+K+3:end, ii);
    deltaBLPSimplex = meanvalnorm([thetaBLP2Simplex;thetaBLP3Simplex]);        % invert out the mean utilities using BLP tastes
    thetadem1 = zeros(D);
    thetadem1(keepdem) = thetaBLP3Simplex;
    MU = zeros(T*prods,nn);
    for rr=1:nn,
        v_i = vfull(:,rr:nn:(K+1)*nn);
        d_i = dfull(:,rr:nn:D*nn);
        MU(:,rr) = (x2.*v_i*thetaBLP2Simplex(:,1))+x2.*(d_i*thetadem1')*ones(K+1,1);
    end
    alphaBLPSimplex = thetaBLP1Simplex(1) + MU(1,:);  
    ElasBLPSimplex = mkelas(exp(deltaBLPSimplex),exp(MU),alphaBLPSimplex);  
    
    
    thetaBLP1 = thetaGMM1tight(1:prods+1, ii);
    thetaBLP2 = thetaGMM1tight(prods+2:prods+1+K+1, ii);
    thetaBLP3 = thetaGMM1tight(prods+K+3:end, ii);
    deltaBLP = meanvalnorm([thetaBLP2;thetaBLP3]);        % invert out the mean utilities using BLP tastes
    thetadem1 = zeros(D);
    thetadem1(keepdem) = thetaBLP3;
    MU = zeros(T*prods,nn);
    for rr=1:nn,
        v_i = vfull(:,rr:nn:(K+1)*nn);
        d_i = dfull(:,rr:nn:D*nn);
        MU(:,rr) = (x2.*v_i*thetaBLP2(:,1))+x2.*(d_i*thetadem1')*ones(K+1,1);
    end
    LipschitzBLP = mklipschitz(exp(deltaBLP),exp(MU));
    LipschBLP(ii,1) = LipschitzBLP;
    alphaBLP = thetaBLP1(1) + MU(1,:);
    ElasBLP = mkelas(exp(deltaBLP),exp(MU),alphaBLP);
 
    thetaBLP1loose = thetaGMM1loose(1:prods+1, ii);
    thetaBLP2loose = thetaGMM1loose(prods+2:prods+1+K+1, ii);
    thetaBLP3loose = thetaGMM1loose(prods+K+3:end, ii);
    deltaBLPloose = meanvalnorm([thetaBLP2loose;thetaBLP3loose]);        % invert out the mean utilities using BLP tastes
    thetadem1 = zeros(D);
    thetadem1(keepdem) = thetaBLP3loose;
    MU = zeros(T*prods,nn);
    for rr=1:nn,
        v_i = vfull(:,rr:nn:(K+1)*nn);
        d_i = dfull(:,rr:nn:D*nn);
        MU(:,rr) = (x2.*v_i*thetaBLP2loose(:,1))+x2.*(d_i*thetadem1')*ones(K+1,1);
    end
    alphaBLPloose = thetaBLP1loose(1) + MU(1,:);  
    ElasBLPloose = mkelas(exp(deltaBLPloose),exp(MU),alphaBLPloose);    

    thetaBLP1loose1 = thetaGMM1loose1(1:prods+1, ii);
    thetaBLP2loose1 = thetaGMM1loose1(prods+2:prods+1+K+1, ii);
    thetaBLP3loose1 = thetaGMM1loose1(prods+K+3:end, ii);
    deltaBLPloose1 = meanvalnorm([thetaBLP2loose1;thetaBLP3loose1]);        % invert out the mean utilities using BLP tastes
    thetadem1 = zeros(D);
    thetadem1(keepdem) = thetaBLP3loose1;
    MU = zeros(T*prods,nn);
    for rr=1:nn,
        v_i = vfull(:,rr:nn:(K+1)*nn);
        d_i = dfull(:,rr:nn:D*nn);
        MU(:,rr) = (x2.*v_i*thetaBLP2loose1(:,1))+x2.*(d_i*thetadem1')*ones(K+1,1);
    end
    alphaBLPloose1 = thetaBLP1loose1(1) + MU(1,:);  
    ElasBLPloose1 = mkelas(exp(deltaBLPloose1),exp(MU),alphaBLPloose1);  
    
    
    thetaMPEC1 = thetaGMMMPEC(1:prods+1, ii);
    thetaMPEC2 = thetaGMMMPEC(prods+2:prods+1+K+1, ii);
    thetaMPEC3 = thetaGMMMPEC(prods+K+3:end, ii);
    deltaMPEC = meanvalnorm([thetaMPEC2;thetaMPEC3]);        % invert out the mean utilities using BLP tastes
    thetadem1 = zeros(D);
    thetadem1(keepdem) = thetaMPEC3;
    MU = zeros(T*prods,nn);
    for rr=1:nn,
        v_i = vfull(:,rr:nn:(K+1)*nn);
        d_i = dfull(:,rr:nn:D*nn);
        MU(:,rr) = (x2.*v_i*thetaMPEC2(:,1))+x2.*(d_i*thetadem1')*ones(K+1,1);
    end
    alphaMPEC = thetaMPEC1(1) + MU(1,:);
    ElasMPEC = mkelas(exp(deltaMPEC),exp(MU),alphaMPEC);

    for aa = 1:prods,
        index = (0:T-1)*prods + aa;
        ElasbarBLPSimplex(aa,:, ii) = mean(ElasBLPSimplex(index,:) );
        save ElasbarBLPSimplex ElasbarBLPSimplex 
        ElasbarBLP(aa,:, ii) = mean(ElasBLP(index,:) );
        save ElasbarBLP ElasbarBLP 
        ElasbarBLPloose(aa,:, ii) = mean(ElasBLPloose(index,:) );
        save ElasbarBLPloose ElasbarBLPloose
        ElasbarBLPloose1(aa,:, ii) = mean(ElasBLPloose1(index,:) );
        save ElasbarBLPloose1 ElasbarBLPloose1
        ElasbarMPEC(aa,:, ii) = mean(ElasMPEC(index,:) );
        save ElasbarMPEC ElasbarMPEC 
    end

end

diary off
