 function [xlow,xupp,Flow,Fupp] = GMMBLPSetup(x)

 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Defines the problem hexagon:
%   maximize the objective row
%   subject to
%            xlow <=   x  <= xupp
%            Flow <= F(x) <= Fupp
%   where
%   
%   F(obj) =  1/(nmkt*(nbrn+1))^2*(Zw)'*Zw ;  %% objective function
%   F(2:neF) = EstShares   ;   %% constraints
% 
%
%   F = [  1/(nmkt*(nbrn+1))^2*(Zw)'*Zw ;     
%       EstShares ] ;
%
% source: Dube, Fox and Su (2008)
% Code Revised: April 2008

global cholesky K

neF    = 1;
n      = size(x, 1);
Obj    = 1; % The default

Flow(Obj)  = -Inf;
Fupp(Obj)  =  Inf;

if cholesky==K,
    xlow = zeros(n,1);
elseif cholesky==K*(K-1)
    xlow = -Inf*ones(n,1);
end
xupp =  Inf*ones(n,1);
