
% This code does a lot of post-processing to create the tables in the
% paper reporting the values of Monte Carlos. 

% Not all features are implemented for NFP loose codes. 


ownelasbartrue = zeros(prods,sims);
ownelasbarGMMloose = zeros(prods,sims);
ownelasbarGMMloose1 = zeros(prods,sims);
ownelasbarGMMtight = zeros(prods,sims);
ownelasbarGMMMPEC = zeros(prods,sims);

for rr = 1:sims,
    ownelasbartrue(:,rr) = diag(Elasbartrue(:,:,rr));
    ownelasbarGMMloose(:,rr) = diag(ElasbarBLPloose(:,:,rr));
    ownelasbarGMMloose1(:,rr) = diag(ElasbarBLPloose1(:,:,rr));
    ownelasbarGMMtight(:,rr) = diag(ElasbarBLP(:,:,rr));
    ownelasbarGMMMPEC(:,rr) = diag(ElasbarMPEC(:,:,rr));
end
ownelasbarGMMlooseRMSE = sqrt( mean(mean( (ownelasbartrue-ownelasbarGMMloose).^2 )) );
ownelasbarGMMloose1RMSE = sqrt( mean(mean( (ownelasbartrue-ownelasbarGMMloose1).^2 )) );
ownelasbarGMMtightRMSE = sqrt( mean(mean( (ownelasbartrue-ownelasbarGMMtight).^2 )) );
ownelasbarGMMMPECRMSE = sqrt( mean(mean( (ownelasbartrue-ownelasbarGMMMPEC).^2 )) );

ownelasbarGMMlooseBIAS = mean(mean( (ownelasbartrue-ownelasbarGMMloose) ));
ownelasbarGMMloose1BIAS = mean(mean( (ownelasbartrue-ownelasbarGMMloose1) ));
ownelasbarGMMtightBIAS = mean(mean( (ownelasbartrue-ownelasbarGMMtight) ));
ownelasbarGMMMPECBIAS = mean(mean( (ownelasbartrue-ownelasbarGMMMPEC) ));


%%% REPEAT BUT DISTINGUISH CONVERGED VERSUS NON-CONVERGED CASES %%%
ownelasbarGMMlooseRMSEconv = sqrt( mean(mean( (ownelasbartrue(:,INFOGMM1loose==0)-ownelasbarGMMloose(:,INFOGMM1loose==0)).^2 )) );
ownelasbarGMMloose1RMSEconv = sqrt( mean(mean( (ownelasbartrue(:,INFOGMM1loose1==0)-ownelasbarGMMloose1(:,INFOGMM1loose1==0)).^2 )) );
ownelasbarGMMtightRMSEconv = sqrt( mean(mean( (ownelasbartrue(:,INFOGMM1tight==0)-ownelasbarGMMtight(:,INFOGMM1tight==0)).^2 )) );
ownelasbarGMMMPECRMSEconv = sqrt( mean(mean( (ownelasbartrue(:,INFOGMMMPEC==0)-ownelasbarGMMMPEC(:,INFOGMMMPEC==0)).^2 )) );

ownelasbarGMMlooseBIASconv = mean(mean( (ownelasbartrue(:,INFOGMM1loose==0)-ownelasbarGMMloose(:,INFOGMM1loose==0)) ));
ownelasbarGMMloose1BIASconv = mean(mean( (ownelasbartrue(:,INFOGMM1loose1==0)-ownelasbarGMMloose1(:,INFOGMM1loose1==0)) ));
ownelasbarGMMtightBIASconv = mean(mean( (ownelasbartrue(:,INFOGMM1tight==0)-ownelasbarGMMtight(:,INFOGMM1tight==0)) ));
ownelasbarGMMMPECBIASconv = mean(mean( (ownelasbartrue(:,INFOGMMMPEC==0)-ownelasbarGMMMPEC(:,INFOGMMMPEC==0)) ));

ownelasbarGMMlooseRMSEnoconv = sqrt( mean(mean( (ownelasbartrue(:,INFOGMM1loose~=0)-ownelasbarGMMloose(:,INFOGMM1loose~=0)).^2 )) );
ownelasbarGMMloose1RMSEnoconv = sqrt( mean(mean( (ownelasbartrue(:,INFOGMM1loose1~=0)-ownelasbarGMMloose1(:,INFOGMM1loose1~=0)).^2 )) );
ownelasbarGMMtightRMSEnoconv = sqrt( mean(mean( (ownelasbartrue(:,INFOGMM1tight~=0)-ownelasbarGMMtight(:,INFOGMM1tight~=0)).^2 )) );
ownelasbarGMMMPECRMSEnoconv = sqrt( mean(mean( (ownelasbartrue(:,INFOGMMMPEC~=0)-ownelasbarGMMMPEC(:,INFOGMMMPEC~=0)).^2 )) );

ownelasbarGMMlooseBIASnoconv = mean(mean( (ownelasbartrue(:,INFOGMM1loose~=0)-ownelasbarGMMloose(:,INFOGMM1loose~=0)) ));
ownelasbarGMMloose1BIASnoconv = mean(mean( (ownelasbartrue(:,INFOGMM1loose1~=0)-ownelasbarGMMloose1(:,INFOGMM1loose1~=0)) ));
ownelasbarGMMtightBIASnoconv = mean(mean( (ownelasbartrue(:,INFOGMM1tight~=0)-ownelasbarGMMtight(:,INFOGMM1tight~=0)) ));
ownelasbarGMMMPECBIASnoconv = mean(mean( (ownelasbartrue(:,INFOGMMMPEC~=0)-ownelasbarGMMMPEC(:,INFOGMMMPEC~=0)) ));


%%%%%%% CPU TIMES %%%%%
timeloosebar = mean(timeGMM1loose,2);
timeloose1bar = mean(timeGMM1loose1,2);
timetightbar = mean(timeGMM1tight,2);
timeMPECbar = mean(timeGMMMPEC,2);

timeloosebarconv = mean(timeGMM1loose(:,INFOGMM1loose==0),2);
timeloose1barconv = mean(timeGMM1loose1(:,INFOGMM1loose1==0),2);
timetightbarconv = mean(timeGMM1tight(:,INFOGMM1tight==0),2);
timeMPECbarconv = mean(timeGMMMPEC(:,INFOGMMMPEC==0),2);

timeloosebarnoconv = mean(timeGMM1loose(:,INFOGMM1loose~=0),2);
timeloose1barnoconv = mean(timeGMM1loose1(:,INFOGMM1loose1~=0),2);
timetightbarnoconv = mean(timeGMM1tight(:,INFOGMM1tight~=0),2);
timeMPECbarnoconv = mean(timeGMMMPEC(:,INFOGMMMPEC~=0),2);



%%%%%%% Function, gradient, Hessian evaluations. Number of contraction mappings. %%%%%

ContractEvalGMM1tightbarconv = mean(ContractEvalGMM1tight(:,INFOGMM1tight==0),2);
HessEvalGMM1tightbarconv = mean(HessEvalGMM1tight(:,INFOGMM1tight==0),2);
FuncEvalGMM1tightbarconv = mean(FuncEvGMM1tight(:,INFOGMM1tight==0),2);
GradEvGMM1tightbarconv = mean(GradEvGMM1tight(:,INFOGMM1tight==0),2);
IterGMM1tightbarconv = mean(IterGMM1tight(:,INFOGMM1tight==0),2);

FuncEvGMMMPECbarconv = mean(FuncEvGMMMPEC(:,INFOGMMMPEC==0),2);
GradEvGMMMPECbarconv = mean(GradEvGMMMPEC(:,INFOGMMMPEC==0),2);
IterGMMMPECbarconv = mean(IterGMMMPEC(:,INFOGMMMPEC==0),2);
HessEvalGMMMPECbarconv = mean(HessEvalGMMMPEC(:,INFOGMMMPEC==0),2);







