
clear
global nn K v report covX costparams betatrue rc rctrue oo report nopurchglobal multistarts scale_global


global y price share W datasort denomexpand sharesum PX x IV setuprc cholesky
global T prods theta1 oo1 rr tol_inner tol_outer nopurch

%%%%%%%%%%%%%%%%%%%%%%%
% Monte Carlo Simulations to compare BLP/NFP versus MPEC
%
% source: Dube, Fox and Su (2008)
% Code Revised: May 2008
%%%%%%%%%%%%%%%%%%%%%%%

diary MC_run.out;

aa = maxNumCompThreads(1);

randn('seed',155)                                   % reset normal random number generator
rand('seed',155)                                    % reset uniform random number generator
nn = 100;                                           % # draws to simulate shares
oo = ones(1,nn);                                    % for use in simulation of shares

costparams = ones(6,1)/2;
betatrue = [1.0 1.5 1.5 .5 -3]';                     % true mean tastes
betatrue0 = betatrue;
K = size(betatrue,1)-1;                             % # attributes
covrc = diag( [ .5 .5 .5 .5 .2] );                  % true co-variances in tastes
rctrue = sqrt(covrc(find(covrc)));
thetatrue = [betatrue;rctrue];
v = randn(length(betatrue),nn);                     % draws for share integrals during estimation
rc = chol(covrc)'*v;                                % draws for share integrals for data creation
sigmaxi=1;
covX = -.8*ones(K-1)+1.8*eye(K-1);                  % allow for correlation in X's
covX(1,3) = .3;
covX(2,3) = .3;
covX(3,1) = .3;
covX(3,2) = .3;

report =100;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Vary the mean intercept                         %%
%%%                                                 %% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
prods = 25;
T = 50;
weak = 4;                                           % weakness of the instruments
sims = 20;                                          % # replications per experiment
BLP=1;
MPEC=1;
elasdo=1;
multistarts = 5;

scale = [-2 -1 0 1 2 3 4];
 
for tt = 1:length(scale),
   
    scale_global = scale(tt);
    betatrue = betatrue0;
    betatrue(1) = scale(tt);
    display(['Starting case with scale = ' num2str(scale_global)])
    
    [theta,Lipschitz] = MC(prods,T,sims,weak,sigmaxi,BLP,MPEC,1,1,elasdo,multistarts,1);      
    Lipschtrue = Lipschitz(:,1);
    if BLP==1,LipschBLP = Lipschitz(:,2);end;
    load 2sls
    load Elasbartrue    
    save(['MCoutBLP_' num2str(T) 'mkts_' num2str(prods) 'products_',num2str(scale_global),'scale'],'betaols','beta2sls','seols','se2sls','betatrue','Elasbartrue', 'Lipschitz','nopurchglobal');
    if BLP==1,
        load GMMstep1tight
        load ElasbarBLP
        biastight = mean( repmat(thetatrue,1,sims)-thetaGMM1tight ,2);
        RMSEtight = sqrt(mean( (repmat(thetatrue,1,sims)-thetaGMM1tight).^2 ,2));
        numcorrecttight = sum( INFOGMM1tight==0);
        save(['MCoutNFPtight_' num2str(T) 'mkts_' num2str(prods) 'products',num2str(scale_global),'scale'],'thetaGMM1tight', 'W', 'Jstat1tight', 'timeGMM1tight', 'FuncEvGMM1tight', 'GradEvGMM1tight', 'covGMM1tight', 'repsGMM1tight', 'INFOGMM1tight', 'ElasbarBLP', 'LipschBLP','innerlooptimetight','biastight','RMSEtight','numcorrecttight');        
        
%         load GMMstep1loose
%         load ElasbarBLPloose
%         biasloose = mean( repmat(thetatrue,1,sims)-thetaGMM1loose ,2);
%         RMSEloose = sqrt(mean( (repmat(thetatrue,1,sims)-thetaGMM1loose).^2 ,2));
%         numcorrectloose = sum( INFOGMM1loose==0);
%         save(['MCoutNFPloose_' num2str(T) 'mkts_' num2str(prods) 'products_',num2str(jj),'intercept'],'thetaGMM1loose', 'W', 'Jstat1loose', 'timeGMM1loose', 'FuncEvGMM1loose', 'GradEvGMM1loose', 'covGMM1loose', 'repsGMM1loose', 'INFOGMM1loose', 'ElasbarBLPloose','LipschBLP','innerlooptimeloose','biasloose','RMSEloose','numcorrectloose');
% 
%         load GMMstep1loose1
%         load ElasbarBLPloose1
%         biasloose1 = mean( repmat(thetatrue,1,sims)-thetaGMM1loose1 ,2);
%         RMSEloose1 = sqrt(mean( (repmat(thetatrue,1,sims)-thetaGMM1loose1).^2 ,2));
%         numcorrectloose1 = sum( INFOGMM1loose1==0);
%         save(['MCoutNFPloose1_' num2str(T) 'mkts_' num2str(prods) 'products_',num2str(jj),'intercept'],'thetaGMM1loose1', 'W', 'Jstat1loose1', 'timeGMM1loose1', 'FuncEvGMM1loose1', 'GradEvGMM1loose1', 'covGMM1loose1', 'repsGMM1loose1', 'INFOGMM1loose1', 'ElasbarBLPloose1','LipschBLP','innerlooptimeloose1','biasloose1','RMSEloose1','numcorrectloose1');
    end
    if MPEC==1,
        load GMMMPEC
        load ElasbarMPEC
        biasMPEC = mean( repmat(thetatrue,1,sims)-thetaGMMMPEC ,2);
        RMSEMPEC = sqrt(mean( (repmat(thetatrue,1,sims)-thetaGMMMPEC).^2 ,2));
        numcorrectMPEC = sum( INFOGMMMPEC==0);
        save(['MCoutMPEC_AllVars_' num2str(T) 'mkts_' num2str(prods) 'products_',num2str(scale_global),'scale'] );
    end
    
    timeGMM1loose = zeros(size(timeGMM1tight) );
    timeGMM1loose1 = zeros(size(timeGMM1tight) );
    INFOGMM1loose = zeros(size(INFOGMM1tight) ) ;
    INFOGMM1loose1 = zeros(size(INFOGMM1tight) ) ;
    ElasbarBLPloose = zeros(size(ElasbarBLP) );
    ElasbarBLPloose1 = zeros(size(ElasbarBLP) );
    
    
    MCpostprocess

    
    save(['tables_AllVars_' num2str(T) 'mkts_' num2str(prods) 'products_',num2str(scale_global),'scale']);
end




