function Dg = gmmblpgrad(theta2)

% Analyticderiv
% Computes the analytic derivatives for the GMM Objective Function
% of the random coefficients Logit demand model estimated via NFP.
%
% source: Dube, Fox and Su (2008)
% Code Revised: May 2008

global prods T nn v K x IV W resid delta


expmu = exp(x*diag(theta2)*v); 
expmval = exp(delta);
[EstShare, simShare] = ind_shnormMPEC(expmval,expmu);

ooo = ones(1,K+1);
ooo1 = ones(prods,1);
dSdtheta2 = zeros(T*prods,K+1);
dSddeltaDIAG = zeros(T*prods,prods);
dSddelta = zeros(T*prods, T*prods);

for tt=1:T,
    index = (1:prods)'+(tt-1)*prods;    
    for rr = 1:nn,
        dSddeltaDIAG(index,:) = dSddeltaDIAG(index,:) + (diag(simShare(index,rr)) - simShare(index,rr)*simShare(index,rr)')/nn;
        dSdtheta2(index,:) = dSdtheta2(index,:) + (simShare(index,rr)*ooo).*(ooo1*v(:,rr)').*( x(index,:) - (ooo1*(simShare(index,rr)'*x(index,:))))/nn;
    end
    dSddelta(index,index) = dSddeltaDIAG(index,:);   
end

% for i = 1:prods
%     for j = 1:prods
%     dSddelta( (j-1)*T+1:j*T, (i-1)*T+1:i*T ) = diag(dSddeltaDIAG((j-1)*T+1:j*T, i)); 
%     end
% end

Ddelta = -myinv(dSddelta)*dSdtheta2;
Dg = 2*Ddelta'*IV*W*IV'*resid;
