function blphess = gmmblphess(theta2)

% Analyticderiv
% Computes the analytic derivatives for the GMM Objective Function
% of the random coefficients Logit demand model estimated via NFP.
%
% source: Dube, Fox and Su (2008)
% Code Revised: May 2008

global prods T nn v K x IV W resid delta PX


expmu = exp(x*diag(theta2)*v); 
expmval = exp(delta);
[EstShare, simShare] = ind_shnormMPEC(expmval,expmu);

ooo = ones(1,K+1);
ooo1 = ones(prods,1);
dSdtheta2 = zeros(T*prods,K+1);
dSddeltaDIAG = zeros(T*prods,prods);
dSddelta = zeros(T*prods, T*prods);

for tt=1:T,
    index = (1:prods)'+(tt-1)*prods;    
    for rr = 1:nn,
        dSddeltaDIAG(index,:) = dSddeltaDIAG(index,:) + (diag(simShare(index,rr)) - simShare(index,rr)*simShare(index,rr)')/nn;
        dSdtheta2(index,:) = dSdtheta2(index,:) + (simShare(index,rr)*ooo).*(ooo1*v(:,rr)').*( x(index,:) - (ooo1*(simShare(index,rr)'*x(index,:))))/nn;
    end
    dSddelta(index,index) = dSddeltaDIAG(index,:);   
end

% for i = 1:prods
%     for j = 1:prods
%     dSddelta( (j-1)*T+1:j*T, (i-1)*T+1:i*T ) = diag(dSddeltaDIAG((j-1)*T+1:j*T, i)); 
%     end
% end

dQddelta = 2*IV*W*IV'*resid;
inv_dSddelta = myinv(dSddelta);
ddeltadtheta2 = -inv_dSddelta*dSdtheta2;
dQdtheta2 = ddeltadtheta2'*dQddelta;

lambdas = inv_dSddelta'*dQddelta;

% Ddelta = -myinv(dSddelta)*dSdtheta2;
% Dg = 2*Ddelta'*IV*W*IV'*resid;

d2Qdtheta22 = zeros(K+1,K+1);

d2Ldtheta22 = zeros(K+1,K+1);
d2Ldtheta22rr = zeros(K+1,K+1);
d2Lddeltadtheta2 = zeros(T*prods, K+1);
d2Lddelta2DIAG = zeros(T*prods,prods);
d2Lddelta2 = zeros(T*prods, T*prods);

% h = h + lambda.ineqnonlin(1)*hessc + lambda.eqnonlin(2)*hessc;

    % Evaluate the hessian
    for tt=1:T,
        index = (1:prods)'+(tt-1)*prods;
        multip = lambdas(index);
        for rr = 1:nn,
            simS = simShare(index,rr);
            sumprod_mpsimS = multip'*simS;
            blk1 = sumprod_mpsimS*(-diag(simS) + 2*simS*simS');
            blk2 = -(multip.*simS)*simS';
            blk3 = diag(multip.*simS);
            
            
            % blk2 = diag((sumprod_mpsimS)*simS');
            % blk3 = diag(sumprod_mpsimS);
            
            % size(blk1)
            % size(blk2)
            % size(blk3)
            
            blk = blk1 + blk2 + blk2'+blk3;    
                
            d2Lddelta2DIAG(index,:) = d2Lddelta2DIAG(index,:) + blk/nn;
            
            xsimSx = x(index,:) - (ooo1*(simS'*x(index,:)));
            xsimSxv = xsimSx.*(ooo1*v(:,rr)');
            dSdtheta2rr = (simS*ooo).*xsimSxv;
            
            d2Lddeltadthetarr = -simS*multip'*dSdtheta2rr - sumprod_mpsimS*dSdtheta2rr + (multip*ooo).*dSdtheta2rr;
            d2Lddeltadtheta2(index,:) = d2Lddeltadtheta2(index,:) + d2Lddeltadthetarr/nn;
            
            d2Ldtheta22rr = ((multip*ooo).*dSdtheta2rr)'*xsimSxv + sumprod_mpsimS*(-dSdtheta2rr'*x(index,:).*(ones(K+1,1)*v(:,rr)')) ;
            
            d2Ldtheta22 = d2Ldtheta22 + d2Ldtheta22rr/nn;
        end
        d2Lddelta2(index,index) = d2Lddelta2DIAG(index,:);
    end
    
    d2Qdtheta22 = - d2Ldtheta22 - ddeltadtheta2'*d2Lddeltadtheta2 ... 
                  - d2Lddeltadtheta2'*ddeltadtheta2 ...
                  - ddeltadtheta2'*d2Lddelta2*ddeltadtheta2 ...
                  + 2*ddeltadtheta2'*(eye(T*prods)-x*PX)'*IV*W*IV'*(eye(T*prods)-x*PX)*ddeltadtheta2;
    
    % blphess = d2Qdtheta22          
              
    blphess = (d2Qdtheta22+d2Qdtheta22')/2;
    