function [G] = gmmblpobj(theta2)

% GMMBLPOBJ
% GMM objective function for the random coefficients Logit estimated via
% the NFP approach proposed by BLP.
%
% source: Dube, Fox and Su (2008)
% Code Revised: April 2008

global iteration x PX IV W K theta1 report rr
global resid delta

delta = meanvalnorm(theta2);        % invert out the mean utilities
if max(isnan(delta)) == 1 || max(abs(theta2))>500,
	G = 1e+10;
    if nargout==2,
        Dg = 1.e+10*ones(1,K+1);
    end
else
    theta1 = PX*delta;
	resid = delta - x*theta1;
	g = resid'*IV;
	G = g*W*g';
    if nargout==2,
        % Dg = analyticderiv(theta2)';
        Dg = gmmblpgrad(theta2)';
      
    end
end

%iteration = iteration +1;
%if iteration/report==ceil(iteration/report),
%    disp(['GMM objective:      ' num2str(G)])
%    disp(['# Function Evals:   ' num2str(iteration)])
%    disp(['MC replication #    ' num2str(rr)]) 
%    disp(' ')
%end
