function f = meanvalnorm(theta2)

% MEANVALNORM
% Invert the mean utility out of the normally-distributed r.c. logit using 
% the contraction-mapping from Berry,Levinsohn and Pakes (1995).
%
% source: Dube, Fox and Su (2008)
% Code Revised: April 2008

global iteration share report tol_inner x v 
global mvalold ContractIter
ii = 0;
%tic;
norm = 1;
mvalold0 = mvalold;

% expmu = exp( mufuncnorm(theta2) );              % compute exponentiated deviations from mean utilities

expmu = exp(x*diag(theta2)*v);      % exponentiated deviations from mean utilities

while norm > tol_inner && ii < 5000,
    
    mval = mvalold0.*share./ind_shnorm(mvalold0,expmu);   
    t = abs(mval-mvalold0);
    norm = max(t);
    avgnorm = mean(t);
    mvalold0 = mval;
    ii = ii + 1;
end;

ContractIter = ContractIter + ii;

if max(isnan(mvalold0))<1, mvalold = mvalold0; end

%fini = toc;
%if iteration/report==ceil(iteration/report),
%    disp(['# of CONTRACTION iterations until delta convergences:  ' num2str(ii)])
%    disp(['time until delta convergences:  ' num2str(fini)])
%end

f = log(mval);
