function MU = mufuncnorm(theta2)

% MUFUNCNORM
% Computes the utility associated with the unobserved component of the r.c.'s.
%
% source: Dube, Fox and Su (2008)
% Code Revised: April 2008

global x v K
global cholesky setuprc

if cholesky==K,
    cholmat = diag(theta2);
elseif cholesky==K*(K-1),
    cholmat = zeros(K+1);
    cholmat(setuprc) = theta2;
end

nu = cholmat*v;
MU = x*nu;