function [theta,G,INFO,CPUt,FuncEval,GradEval,reps,Dg,cov,BLP_Iter,HessEval,ContractEvalBLP] = runGMMBLPTomlab(theta00,W,mvalold0,deriv,gradient)

% run GMMBLPTomlab
% Run the GMM estimation of the random coefficients Logit demand model estimated via NFP.
%
% source: Dube, Fox and Su (2008)
% Code Revised: May 2008
 
global iteration mvalold theta1 T prods tol_inner rr ContractIter


mvalold = mvalold0;
ContractIter = 0;

% Setup the lower and upper bounds for varialbes and constraints

[thetalow,thetaupp,Flow,Fupp] = GMMBLPSetup(theta00);

if tol_inner==1.e-14,
    Name = 'BLP NFP Problem with tight inner-loop tolerance';
else
    Name = 'BLP NFP Problem with loose inner-loop tolerance';
end

fLowBnd = 0;         % Lower bound on function.
if nargin==5,
    Prob = conAssign('gmmblpobj', 'gmmblpgrad', 'gmmblphess', [], thetalow, thetaupp, Name, theta00,...
        [], fLowBnd, [], [], [], [], [], [], [], [], []);
else
    Prob = conAssign('gmmblpobj', [], [], [], thetalow, thetaupp, Name, theta00,...
        [], fLowBnd, [], [], [], [], [], [], [], [], []);
    Prob.ConsDiff = 6;
    Prob.NumDiff = 6;
end
%Prob.PriLevOpt = 1;
Prob.PriLevOpt = 3;
Prob.KNITRO.PrintFile = '';
Prob.KNITRO.options.ALG = 1;        % Select feasible KNITRO
Prob.KNITRO.options.MAXIT = 100;    % Setting maximum number of iterations
% Prob.KNITRO.options.HESSOPT = 2;    % to be used along with first-order derivatives

BLP_Result = tomRun('knitro', Prob, 1);

theta = BLP_Result.x_k;
G = BLP_Result.f_k;
INFO = BLP_Result.Inform;
CPUt = BLP_Result.CPUtime;

FuncEval = BLP_Result.FuncEv;
GradEval = BLP_Result.GradEv;

BLP_Iter = BLP_Result.Iter;
HessEval = BLP_Result.HessEv;
ContractEvalBLP = ContractIter;

theta00 = theta;



if deriv==1,    %4
    Dg = mkderivGMMnorm(theta1,theta,1.e-5);
    cov = inv(Dg*W*Dg')/(T*prods);
end

reps = 1; % old argument





