function f = invertnfp_finmix(expVjnetxi,mu)

% INVERT_FINMIX
% Invert the vector of demand shocks, \xi, out of the predicted shares for
% the finite mixture random coefficients Logit.
% Inversion using NFP with adaptation of the contraction-mapping from Berry,Levinsohn and Pakes (1995).
%
% Jean-Pierre Dube, May 2008

global Sh tol_inner
global expxi0
ii = 0;
%tic;
norm = 1;
expxi0tem = expxi0;
while norm > tol_inner && ii < 1500,
    expxi = expxi0tem.*Sh./sharenfp_finmix(expxi0tem,expVjnetxi,mu);
    t = abs(expxi-expxi0tem);
    norm = max(t);
    avgnorm = mean(t);
    expxi0tem = expxi;
    ii = ii + 1;
end;
%if sum(isnan(expxi0tem))==0 && isreal(expxi0tem)==1, expxi0 = expxi0tem; end

%fini = toc;
%if iteration/report==ceil(iteration/report),
%    disp(['# of CONTRACTION iterations until delta convergences:  ' num2str(ii)])
%    disp(['time until delta convergences:  ' num2str(fini)])
%end

f = log(expxi0tem);