function f = invertnfp_finmix(expVjnetxi,mu)

% INVERT_FINMIX
% Invert the vector of demand shocks, \xi, out of the predicted shares for
% the finite mixture random coefficients Logit.
% Inversion using NFP with adaptation of the contraction-mapping from Berry,Levinsohn and Pakes (1995).
%
% Jean-Pierre Dube, May 2008

global Sh tol_inner
global expxi0
ii = 0;
%tic;
norm = 1;
normderiv=1;
expxi0tem = expxi0+mu(1)-mu(1);
while (norm > tol_inner || normderiv>1.e-12) && ii < 1000,
%while (norm > tol_inner || normderiv>tol_inner),
    expxi = expxi0tem.*Sh./sharenfp_finmix(expxi0tem,expVjnetxi,mu);
    t = expxi-expxi0tem;
    norm = max(abs(t));
%    normderiv = max(max(getinternalderivs(t)));
    normderiv = max(max( abs(squeeze(getinternalderivs(t))) ));
    if isempty(normderiv), normderiv = 0; end;
    avgnorm = mean(t);
    expxi0tem = expxi;
    ii = ii + 1;
end;

f = log(expxi0tem);